from fastapi.testclient import TestClient

from fimportal.xdatenfelder import xdf2, xdf3
from tests.conftest import CommandRunner
from tests.factories.xdf2 import Xdf2Factory
from tests.factories.xdf3 import Xdf3Factory


def test_should_return_the_schema_in_xdf2_form(
    runner: CommandRunner, client: TestClient
):
    schema_import = Xdf2Factory().schema().full().build_import()
    runner.import_xdf2(schema_import)

    message = schema_import.schema_message

    response = client.get(f"/api/v1/schemas/{message.id}/{message.version}/xdf")

    assert response.status_code == 200
    assert response.headers["content-type"] == "application/xml"
    assert (
        response.headers["content-disposition"]
        == f'attachment; filename="{message.id}V{message.version}.xdf2.xml"'
    )

    parsed_message = xdf2.parse_schema_message(response.read())

    # Patch the message header, as this is generated by the server and not part of the actual data.
    parsed_message.header = message.header

    assert parsed_message == message


def test_should_return_the_schema_in_xdf3_form(
    runner: CommandRunner, client: TestClient
):
    schema_import = Xdf3Factory().schema().full().build_import()
    runner.import_xdf3(schema_import)

    message = schema_import.schema_message

    response = client.get(f"/api/v1/schemas/{message.id}/{message.version}/xdf")

    assert response.status_code == 200
    assert response.headers["content-type"] == "application/xml"
    assert (
        response.headers["content-disposition"]
        == f'attachment; filename="{message.id}V{message.version}.xdf3.xml"'
    )

    parsed_message = xdf3.parse_schema_message(response.read())

    # Patch the message header, as this is generated by the server and not part of the actual data.
    parsed_message.header = message.header

    assert parsed_message == message


def test_should_work_with_latest(runner: CommandRunner, client: TestClient):
    schema = Xdf2Factory().schema().full().save(runner)

    response = client.get(f"/api/v1/schemas/{schema.fim_id}/latest/xdf")

    assert response.status_code == 200
    assert response.headers["content-type"] == "application/xml"
    assert (
        response.headers["content-disposition"]
        == f'attachment; filename="{schema.fim_id}V{schema.fim_version}.xdf2.xml"'
    )


def test_should_fail_for_unknown_schema(client: TestClient):
    response = client.get("/api/v1/schemas/S123456/1.0/xdf")

    assert response.status_code == 404
    assert response.json() == {"detail": "Could not find schema S123456V1.0."}
